<script lang="ts">
	import { SshAccessType } from "../../types";
	import CardButton from "../../ui/CardButton.svelte";

	export let accessType: SshAccessType | null;
	export let portNumber: number | null;
	export let loginUsername: string;
	export let sudoPassword: string;
	export let publicKeyAdded: boolean;
	export let portsOpened: boolean;
	export let hostName: string;

	export let homeDirectoryPath: string;

	let isSudoPasswordVisible = false;

	let setAccessType = function (newValue: SshAccessType): void {
		accessType = newValue;

		if (newValue === SshAccessType.Root) {
			loginUsername = 'root';
		} else {
			if (loginUsername === 'root') {
				loginUsername = '';
			}
		}
	};
</script>

<p class="lead">
	My <strong>Ubuntu LTS x86/amd64</strong> server's SSH listens on port:
	<input
		type="number"
		step="1"
		min="1"
		max="65535"
		class="form-control d-inline-block w-auto"
		bind:value={portNumber}
		required={true}
	/>
</p>

<p class="lead">
	I will provide SSH access to my server in the following way:
</p>

<div class="row">
	<div class="col-md-4 mb-2">
		<CardButton
			multipleSelect={false}
			active={accessType === SshAccessType.Root}
			faded={accessType !== SshAccessType.Root && accessType !== null}
			on:activated={() => setAccessType(SshAccessType.Root)}
		>
			<div slot="card-body-heading">
				<h4 class="fs-5">
					<i class="fa-solid fa-fw fa-user"></i>
					Direct <code>root</code> access
				</h4>
			</div>

			<div slot="card-body-content">
				Login using <code>root</code> directly, without using <code>sudo</code> and passwords
			</div>
		</CardButton>
	</div>

	<div class="col-md-4 mb-2">
		<CardButton
			multipleSelect={false}
			active={accessType === SshAccessType.SudoWithoutPassword}
			faded={accessType !== SshAccessType.SudoWithoutPassword && accessType !== null}
			on:activated={() => setAccessType(SshAccessType.SudoWithoutPassword)}
		>
			<div slot="card-body-heading">
				<h4 class="fs-5">
					<i class="fa-solid fa-fw fa-user-shield"></i>
					<code>sudo</code> <strong>without</strong> a password
				</h4>
			</div>

			<div slot="card-body-content">
				Login using a regular user, which can elevate to <code>root</code> via <code>sudo</code> <strong>without</strong> a password
			</div>
		</CardButton>
	</div>

	<div class="col-md-4 mb-2">
		<CardButton
			multipleSelect={false}
			active={accessType === SshAccessType.SudoWithPassword}
			faded={accessType !== SshAccessType.SudoWithPassword && accessType !== null}
			on:activated={() => setAccessType(SshAccessType.SudoWithPassword)}
		>
			<div slot="card-body-heading">
				<h4 class="fs-5">
					<i class="fa-solid fa-fw fa-user-lock"></i>
					<code>sudo</code> <strong>with</strong> a password
				</h4>
			</div>

			<div slot="card-body-content">
				Login using a regular user, which elevates to <code>root</code> via <code>sudo</code> <strong>with</strong> a password
			</div>
		</CardButton>
	</div>
</div>

{#if accessType}
	<div class="mb-2">
		<label for="hostName" class="mb-1">
			<i class="fa-solid fa-fw fa-globe"></i>
			SSH Server (IP)
		</label>

		<input
			type="text"
			class="form-control"
			id="hostName"
			bind:value={hostName}
			placeholder="1.2.3.4"
			required={true}
		/>
	</div>

	{#if accessType !== SshAccessType.Root}
		<div class="mb-2">
			<label for="loginUsername" class="mb-1">
				{#if accessType === SshAccessType.SudoWithPassword}
					<i class="fa-solid fa-fw fa-user-lock"></i>
				{:else}
					<i class="fa-solid fa-fw fa-user-shield"></i>
				{/if}
				SSH Login Username
			</label>

			<input
				type="text"
				class="form-control"
				id="loginUsername"
				bind:value={loginUsername}
				placeholder="etke"
				required={true}
				/>
			{#if loginUsername === "root"}
				<div class="alert alert-warning mt-2">It looks like you mean Direct root access instead?</div>
			{/if}
		</div>
	{/if}

	{#if accessType === SshAccessType.SudoWithPassword}
		<div class="mb-2">
			<label for="sudoPassword" class="mb-1">
				<i class="fa-solid fa-fw fa-lock"></i>
				<code>sudo</code> password
			</label>

			<div class="input-group">
				{#if isSudoPasswordVisible}
					<input
						type="text"
						class="form-control"
						id="sudoPassword"
						bind:value={sudoPassword}
						required={true}
						/>
				{:else}
					<input
						type="password"
						class="form-control"
						id="sudoPassword"
						bind:value={sudoPassword}
						required={true}
						/>
				{/if}

				<button
					class="btn btn-outline-secondary" type="button"
					on:click={() => { isSudoPasswordVisible = !isSudoPasswordVisible; } }
				>
					<i class={isSudoPasswordVisible ? 'fa-regular fa-eye-slash' : 'fa-regular fa-eye'} ></i>
				</button>
			</div>
		</div>
	{/if}
{/if}


<label class="form-check form-switch d-block lead mb-2">
	<input class="form-check-input" type="checkbox" bind:checked={portsOpened} />
	<span class="form-check-label">
		I have opened all needed network ports as specified in <a target="_blank" href="/order/status/#ports-and-firewalls">this guide</a>
	</span>
</label>

<label class="form-check form-switch d-block lead mb-2">
	<input class="form-check-input" type="checkbox" bind:checked={publicKeyAdded} />
	<span class="form-check-label">
		I have granted access to <a target="_blank" href="/keys.txt">etke.cc's SSH keys</a>
	</span>
</label>


<ul class="text-secondary">
	<li>
		The <code>{homeDirectoryPath}/.ssh/authorized_keys</code> file needs to contain all the keys
	</li>

	<li>
		The permissions of the <code>{homeDirectoryPath}/.ssh/authorized_keys</code> file need to be <code>600</code>
		(run: <code>chmod 600 {homeDirectoryPath}/.ssh/authorized_keys</code>)
	</li>

	<li>
		The permissions of the <code>{homeDirectoryPath}/.ssh</code> directory need to be <code>700</code>
		(run: <code>chmod 700 {homeDirectoryPath}/.ssh</code>)
	</li>

	<li>
		Your firewall should allow connections to SSH (<code>tcp/{portNumber}</code>) from the whole world
	</li>
</ul>
